# S2MLCore version 1.1.1
# S2MLParameter.py
# by Antoine Rauzy
# Copyrights (c) 2018-2022 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Parameters

# 1) Imported modules
# -------------------

from S2MLDomains import *
from S2MLMetaModel import *

from S2MLType import *
from S2MLStochasticExpression import *

# 2) Creator
# ----------

class S2MLParameter(S2MLPort):
  def __init__(self, domain, path, container):
    S2MLPort.__init__(self, S2MLType.PARAMETER, domain, path, container)
    self._definition = None
    self._value = S2MLConstant.NewNone()

# 3) Accessors
# ------------

  def GetDefinition(self):
    return self._definition

  def SetDefinition(self, expression):
    self._definition = expression

  def IsValueCalculated(self):
    return not self._value.IsNone()

  def ResetValue(self):
    self._value.Reset()

  def GetValue(self):
    return self._value

  def SetValue(self, value):
    self._value.Set(value)

  def GetBaseType(self):
    return S2MLConstant.ANY



