# S2ML version 1.1.1
# S2MLModelRewriter.py
# by Antoine Rauzy
# Copyrights (c) 2018-2022 AltaRica Association
#
# This file is part of S2ML, a.
# S2ML is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2ML is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2ML.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Creator
# 3) Error management
# 4) Post-processing

# 1) Imported modules
# -------------------

from S2MLModels import *

# 2) Creator
# ----------

class S2MLModelRewriter:
  def __init__(self, engine):
    from S2MLEngine import S2MLEngine
    self._engine = engine

# 3) Error management
# -------------------

  def GetNumberOfErrors(self):
    return self._errors

  def RaiseError(self, message):
    fullMessage = ""
    self._errors += 1
    if self._errors>1:
      fullMessage += "\n"
    fullMessage += "Error %d\n" % self._errors
    fullMessage += message
    self._engine.RaiseError(message)

# 4) Post-processing
# ------------------

  def PostProcessModel(self, model):
    return 0
