# Janos version 1.2.1
# JanosModelManager.py
# by Antoine Rauzy
# Copyrights (c) 2018-2022 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Creator
# 3) Accessors
# 4) Models

# 1) Imported modules
# -------------------

from JanosModels import *
from JanosInterface import *

from JanosModelChecker import *
from JanosModelFlattener import *
from JanosModelRewriter import *

# 2) Creator
# ----------

class JanosModelManager(S2MLModelManager):
  def __init__(self, engine):
    from JanosEngine import JanosEngine
    S2MLModelManager.__init__(self, engine)

# 3) Accessors
# ------------

  # To be overloaded
  def CreateTools(self):
    self._modelLexer = JanosModelLexer(self._engine)
    self._modelParser = JanosModelParser(self._engine)
    self._modelPrinter = JanosModelPrinter(self._engine)
    self._modelChecker = JanosModelChecker(self._engine)
    self._modelFlattener = JanosModelFlattener(self._engine)
    self._modelRewriter = JanosModelRewriter(self._engine)
    self._forceFlattening = True

# 4) Models
# ---------

  def NewModel(self):
    return JanosModel()

